> For the complete documentation index, see [llms.txt](https://docs.irrevocable.dev/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.irrevocable.dev/sdk-reference/execution-constraints.md).

# Execution Constraints

The method defines the conditions that govern the execution of the circuit, allowing developers to limit runs based on criteria such as time frame or number of successful completions.

{% hint style="info" %}
If no `executionConstraints` are added then the Lit Action Code will run according to the `setConditions` and `conditionalLogic`.
{% endhint %}

{% code overflow="wrap" fullWidth="true" %}

```typescript
const executionOptions = {
    conditionMonitorExecutions: 10,
    startDate: new Date("2023-07-01T00:00:00Z"),
    maxLitActionCompletions: 3
}

newCircuit.executionConstraints(executionOptions);
```

{% endcode %}

**Execution Constraints Parameters:**

{% code overflow="wrap" fullWidth="true" %}

```typescript
/* Optional. The maximum amount of times that the circuit will run before 
    stopping, inclusive of conditions on matched, on unmatched and conditional logic failures.*/
conditionMonitorExecutions?: number;

/* Optional. The circuit will not run before this date.*/
startDate?: Date;

/* Optional. The circuit will stop running once this date has passed.*/
endDate?: Date;

/* Optional. The maximum amount of times that the Lit Action code will be 
    executed before the circuit stops running. This is a full run of the circuit.*/
maxLitActionCompletions?: number;
```

{% endcode %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.irrevocable.dev/sdk-reference/execution-constraints.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
